#ifndef _KGR_PATCH_BSC1004419_H
#define _KGR_PATCH_BSC1004419_H

#if defined(CONFIG_X86_64)
int kgr_patch_bsc1004419_init(void);
struct page *kgr_follow_page_mask(struct vm_area_struct *vma,
	unsigned long address, unsigned int flags, unsigned int *page_mask);
long kgr__get_user_pages(struct task_struct *tsk, struct mm_struct *mm,
		unsigned long start, unsigned long nr_pages,
		unsigned int gup_flags, struct page **pages,
		struct vm_area_struct **vmas, int *nonblocking);
#else
int kgr_patch_bsc1004419_init(void)
{
       return 0;
}

/*
 * No other functions defined here is intentional. Should cause build error.
 * We do not want to patch it on other archs, so this enforces #ifdef in
 * kgr_patch structure.
 */
#endif

#endif
